/* SAMPLE FILE for PTM */
/* filename: convol.c  */
/* arch: SUN4          */

/* This program convolutes a image array of maximum size of 64x64 */
/* with a 3x3 convolution mask                                    */
/* The first argument is the image array pointed by hARGV[0].iptr */
/* the second argument is the mask pointed by hARGV[1].iptr       */

#include "pvm3.h"
#include "ptmc.h"
#define MAXSIZE 64 

main()
{
   int data[MAXSIZE][MAXSIZE];
   int filter[3][3];
   int result[MAXSIZE][MAXSIZE];
   int i,j,fi,fj,di,dj;
   int total=0;
   int ysize,xsize;

   hBEGIN();

      ysize = hARGV[0].rows;
      xsize = hARGV[0].cols;

      for (i=0;i<hARGV[0].rows;i++)
         for (j=0;j<hARGV[0].cols;j++)
             data[i][j] = hARGV[0].iptr[i*hARGV[0].cols+j];

      for (i=0;i<hARGV[1].rows;i++)
         for (j=0;j<hARGV[1].cols;j++) {
            filter[i][j] = hARGV[1].iptr[i*hARGV[1].cols+j];
            total += filter[i][j];
         }

      for (i=0;i<ysize;i++)
         for (j=0;j<xsize;j++) {
            result[i][j] = 0;
            for (fi=0;fi<3;fi++) {
               for (fj=0;fj<3;fj++) {
                  di = i+1-fi;
                  dj = j+1-fj;
                  if ((di>=0)&&(dj>=0)&&(di<ysize)&&(dj<xsize)) {
                     result[i][j] += data[di][dj]*filter[fi][fj];
	          }
	       }
	    }
            if (abs(total)>1)
               result[i][j] = result[i][j]/total;
         }

     hRETC = 1;
     hRETV[0].rows = hARGV[0].rows;
     hRETV[0].cols = hARGV[0].cols;
     hRETV[0].dims = hARGV[0].dims;
     hRETV[0].type = hARGV[0].type;

     hRETV[0].iptr=(int *)calloc(hRETV[0].rows*hRETV[0].cols,sizeof(int));
     for (i=0;i<hRETV[0].rows;i++)
	for (j=0;j<hRETV[0].cols;j++)
           hRETV[0].iptr[i*hRETV[0].cols+j]=result[i][j];

   hEND();

}


