/* convolution program implemented on Paragon */
#include "pvm3.h"
#include "ptmc.h"
#define MAXSIZE 64 

main()
{
   int data[MAXSIZE][MAXSIZE];
   int filter[3][3];
   int result[MAXSIZE][MAXSIZE];
   int i,j,fi,fj,di,dj;
   int total=0;
   int ysize,xsize;
   int startx,starty;
   int endx,endy;
   int iam,nprocs,master;
   int size;

   hBEGIN();

   /* use NX commands to determine self's ID and number of peers */

   iam = mynode();
   nprocs = numnodes(); 
   if (hID==0) {
      master = iam;
      for (i=0;i<nprocs;i++)
         if (i!=iam)
            csend(99,&master,sizeof(int),i,myptype());
   }
   else {
      crecv(99,&master,sizeof(int));
   }

   /* Partition the image by rows */

   ysize = hARGV[0].rows/nprocs;
   xsize = hARGV[0].cols;
   starty = iam*ysize;
   if (iam+1==nprocs)
      endy = hARGV[0].rows;
   else
      endy = starty+ysize;

   for (i=0;i<hARGV[0].rows;i++)
      for (j=0;j<hARGV[0].cols;j++)
         data[i][j] = hARGV[0].iptr[i*hARGV[0].cols+j];

   for (i=0;i<hARGV[1].rows;i++)
      for (j=0;j<hARGV[1].cols;j++) {
         filter[i][j] = hARGV[1].iptr[i*hARGV[1].cols+j];
            total += filter[i][j];
         }

   for (i=starty;i<endy;i++)
      for (j=0;j<xsize;j++) {
         result[i][j] = 0;
         for (fi=0;fi<3;fi++) {
            for (fj=0;fj<3;fj++) {
               di = i+1-fi;
               dj = j+1-fj;
               if ((di>=0)&&(dj>=0)&&(di<hARGV[0].rows)&&(dj<xsize)) {
                  result[i][j] += data[di][dj]*filter[fi][fj];
               }
            }
         }
         if (abs(total)>1)
            result[i][j] = result[i][j]/total;
      }

    if (hID!=0) {
       size = sizeof(int) * (endy-starty) * MAXSIZE;
       csend(iam,&result[starty][0],size,master,myptype());   
    }
    else { 
       for (i=0;i<nprocs;i++) {
          if (i!=iam) {
             if (i+1==nprocs)
                size = sizeof(int) * (hARGV[0].rows-(nprocs-1)*ysize) * MAXSIZE;
             else
                size = sizeof(int) * ysize * MAXSIZE;
             crecv(i,&result[i*ysize][0],size);
          }
       }
       hRETC = 1;
       hRETV[0].rows = hARGV[0].rows;
       hRETV[0].cols = hARGV[0].cols;
       hRETV[0].dims = hARGV[0].dims;
       hRETV[0].type = hARGV[0].type;

       hRETV[0].iptr=(int *)calloc(hRETV[0].rows*hRETV[0].cols,sizeof(int));
       for (i=0;i<hRETV[0].rows;i++)
          for (j=0;j<hRETV[0].cols;j++)
             hRETV[0].iptr[i*hRETV[0].cols+j]=result[i][j];
    }

    hEND();

}


