/* header file for ptm tasks */
/* ptmc.h */

#define MAXVAR 32
#define MAXTASK 16
#define MAXPARA 8
#define MAXSTR 64

#define INT 0
#define REAL 1
#define CHAR 2
#define NAME 3

int hTID;
int hMASTER;
int hID;
int hARGC;
int hRETC=0;
int hNPROC;
int hTIDS[MAXTASK];

struct hargv {
   int type; /* type of argument */
   int dims; /* number of dimension */
   int rows; /* number of rows */
   int cols; /* number of cols */
   int *iptr; /* integer array pointer - 1 dimensional */
   float *rptr; /* real array pointer - 1 dimensional */
   char cptr[MAXSTR]; /* char array pointer */
} hARGV[MAXPARA], hRETV[MAXPARA];

#define hBEGIN() \
{ \
   int hI,hROWS,hCOLS,hSIZE; \
   int hMSGTYPE = 0; \
   hTID = pvm_mytid(); \
   hMASTER = pvm_parent(); \
   pvm_recv(hMASTER,hMSGTYPE); \
   pvm_upkint(&hNPROC,1,1); \
   pvm_upkint(hTIDS,hNPROC,1); \
   pvm_upkint(&hARGC,1,1); \
   for (hI=0;hI<hARGC;hI++) { \
      pvm_upkint(&hARGV[hI].type,1,1); \
      pvm_upkint(&hARGV[hI].rows,1,1); \
      pvm_upkint(&hARGV[hI].cols,1,1); \
      hROWS = hARGV[hI].rows; \
      hCOLS = hARGV[hI].cols; \
      hSIZE = hROWS*hCOLS; \
      if (hCOLS) { \
	 hARGV[hI].dims = 2; \
      } \
      else \
      { \
	 hCOLS = 1; \
	 hARGV[hI].cols = 1; \
	 hARGV[hI].dims = 1; \
      } \
      switch(hARGV[hI].type) \
      { \
      case INT: \
	 hARGV[hI].iptr = (int *)calloc(hSIZE,sizeof(int)); \
	 pvm_upkint(hARGV[hI].iptr,hSIZE,1); \
	 break; \
      case REAL: \
	 hARGV[hI].rptr = (float *)calloc(hSIZE,sizeof(float)); \
	 pvm_upkfloat(hARGV[hI].rptr,hSIZE,1); \
	 break; \
      case CHAR: \
	/* hARGV[hI].cptr = (char *)calloc(hSIZE+1,sizeof(char)); \
	*/ pvm_upkstr(hARGV[hI].cptr); \
	 break; \
      case NAME: \
	/* hARGV[hI].cptr = (char *)calloc(hSIZE+1,sizeof(char)); \
	*/ pvm_upkstr(hARGV[hI].cptr); \
	 break; \
      } \
   } \
   for (hI=0;hI<hNPROC;hI++) \
   { \
      if (hTID == hTIDS[hI]) \
      { \
	 hID = hI; \
	 break; \
      } \
   } \
}


#define hEND() \
{ \
   int hMSGTYPE=1; \
   int hSIZE,hI; \
   if (hID==0) { \
      pvm_initsend(PvmDataDefault); \
      pvm_pkint(&hRETC,1,1); \
      for (hI=0;hI<hRETC;hI++) \
      { \
	 hSIZE = hRETV[hI].rows*hRETV[hI].cols; \
	 pvm_pkint(&hRETV[hI].type,1,1); \
	 pvm_pkint(&hRETV[hI].rows,1,1); \
	 if (hRETV[hI].dims==1) \
	    hRETV[hI].cols = 0; \
	 pvm_pkint(&hRETV[hI].cols,1,1); \
	 switch(hRETV[hI].type) \
	 { \
	 case INT: \
	 pvm_pkint(hRETV[hI].iptr,hSIZE,1); \
	 break; \
	 case REAL: \
	 pvm_pkfloat(hRETV[hI].rptr,hSIZE,1); \
	 break; \
	 case CHAR: \
	 pvm_pkstr(hRETV[hI].cptr); \
	 break; \
	 } \
      } \
      pvm_send(hMASTER,hMSGTYPE); \
   } \
   pvm_exit(); \
}


#define hABORT() \
{ \
   int hMSGTYPE = 1; \
   int hERROR = -1; \
   pvm_initsend(PvmDataDefault); \
   pvm_pkint(&hERROR,1,1); \
   pvm_send(hMASTER,hMSGTYPE); \
   pvm_exit(); \
}

